/*
Klasse klassenMaler zum anzeigen der Informationen einer Klasse
fr ein UML-Klassendiagramm.
Autor: Karsten
Version: 02/01/01
*/

import java.awt.*;
import java.awt.font.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.text.*;
import java.util.Vector;
import javax.swing.*;


public class klassenMaler extends Frame implements ActionListener{

/*
Zunchst einmal fhren wir die ntigen Parameter ein, die zum vollstndigen anzeigen einer Klasse ntig sind.
Alle werden gleich mit "Settern" versehen.
*/

private String Filename="";
private void setnFilename(String nFilename) {
    Filename = nFilename;
}

private String Name="";
private void setnName(String nName){ //setName ist als Name schon vergeben.
	Name = nName;}

private String Stereotyp="";
private void setStereotyp(String nStereo){
	Stereotyp = nStereo;}

private String Paket="";
private void setPaket(String nName){
	Paket = nName;}

private String PaketKlasse="";
private void setPaketKlasse(String nName){
	PaketKlasse = nName;}

private boolean isStatic=true;
private void setisStatic(boolean nName){
	isStatic = nName;}

private int Eigenschaften=1;
private void setEigenschaften(int nName){
	Eigenschaften = nName;}

private Vector Attribute = new Vector();
private void setAttribute(Vector nName){
	Attribute = nName;}

private Vector Operationen = new Vector();
private void setOperationen(Vector nName){
	Operationen = nName;}

private String Eigenschaftswerte="";
private void setEigenschaftswerte(String nName){
	Eigenschaftswerte = nName;}


/*
Der Parameter "ausfhrlich"  steht fr den Detailliertheitsgrad der Anzeige.
0 entspricht "knapp"
1 entspricht "normal"
2 entspricht "detailliert"
*/
private int ausfuehrlich =2;

/*
die Koordinaten der oberen linken Ecke des Kstchens.private int xkoord= 20
die sind variabel, damit man die entsprechenden Teile spter weiter verwenden kann
*/
private int ykoord = 20;
private int xkoord = 20;

/*
Hilfsobjekte, um spter den "Eigenschaften-String" umbrechen zu knnen
*/
private AttributedCharacterIterator iterM;
private LineBreakMeasurer lbreakM;

/*
Damit man weiss, wie gro der Rahmen ist
*/
private Insets inset;
  JButton jButton1 = new JButton();
  JCheckBox jCheckBox1 = new JCheckBox();
  JCheckBox jCheckBox2 = new JCheckBox();
  JLabel jLabel1 = new JLabel();
  JRadioButton jRadioButton1 = new JRadioButton();


	/*
	Konstruktor sorgt dafr, dass ein Frame aufgemacht wird, der
	a) wegkllckbar ist,
	b) eine noch veraenderbare Groesse hat.
	c) um seine Insets (die vom Rahmen verschluckte Flche) wei
	*/
	public klassenMaler(){
		super("Klassen-Anzeige");
		addWindowListener(
   		new WindowAdapter(){
   			public void windowClosing(WindowEvent event){
   				event.getWindow().setVisible(false);
   			}
   		}
   		);
   		setBackground(Color.white);
   		setSize(400,500);
   		setVisible(true);
   		inset = getInsets();
   		setMenuBar(new menue(this));
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
   	}// Ende Konstruktor


   	 public static void malen(Klasse kla) {
   	 	klassenMaler grosz = new klassenMaler();
   	 	grosz.setnFilename(kla.getFilename());
   	 	grosz.setnName(kla.getName());
   	 	grosz.setStereotyp(kla.getStereotyp());
   	 	grosz.setPaket(kla.getPaket());
   	 	grosz.setPaketKlasse(kla.getPaketKlasse());
   	 	grosz.setEigenschaftswerte(kla.getEigenschaftswerte());
   	 	grosz.setisStatic(kla.getisStatic());
   	 	grosz.setEigenschaften(kla.getEigenschaften());
   	 	grosz.setAttribute(kla.getAttribute());
   	 	grosz.setOperationen(kla.getOperationen());
   	   	grosz.repaint();
   	}



	public void paint(Graphics g) {
		/*
		das casten braucht man, um nachher layouts anzeigen zu knnen.
		*/
		Graphics2D g2d = (Graphics2D)g;
		/*
		das hier sind die ntigen Hilfskonstruktionen fr das umbrechen der drei
		"lngeren" Strings, Merkmale, Attribute und Operationen.
		*/
		g2d.setColor(Color.black);
		/*
		Nur fr die explizit als Strings angezeigten Elemente
		verwenden wir eine besondere Schriftart. Das geht dann
		nachher einfacher.
		*/
		Font Font;
		Font = new Font("SansSerif",1,15);
		g2d.setFont(Font);
		/*
		Jetzt kommen ein paar Objekte, die man braucht, um Text umbrechen zu koennen.
		ein Layout, das spter angezeigt wird, einen Fontrenderkontext, der zum Beispiel
		um die Gre der Schrift wei sowie einen Iterator, der immer Teile des attributierten
		Strings ausgibt.
		Das ganze brauchen wir fr alle Elemente, die u.u. aus mehr als einem Wort bestehen.
		*/
		TextLayout layout;
		FontRenderContext fcontext = ((Graphics2D)getGraphics()).getFontRenderContext();


		/*
		Jetzt werden die aus den CheckBoxen bzw. Listen gewonnenen Informationen
		ber die Klasse in den String, der die weiteren Merkmale enthlt, integriert.
		*/
		String gesamteEigenschaften;
		if (isStatic) gesamteEigenschaften= "static, " + Eigenschaftswerte;
		else gesamteEigenschaften = Eigenschaftswerte;

		switch(Eigenschaften){
			case 0: gesamteEigenschaften = "{public, " + gesamteEigenschaften + "}";
			case 1: gesamteEigenschaften = "{private, " + gesamteEigenschaften + "}";
			case 2: gesamteEigenschaften = "{protected, " + gesamteEigenschaften + "}";
		}

		/*
		initilaisierung der Hilfsobjekte zum Umbrechen des Strings
		*/

		iterM = (new AttributedString(gesamteEigenschaften)).getIterator();
		lbreakM = new LineBreakMeasurer(iterM,fcontext);
		lbreakM.setPosition(0);


		/*
		Der "beschreibbare" Platz liegt ausschlielich im innern des
		Frames.
		*/
		float xins = inset.left;
		float yins = inset.top;

		/*
		Problem: eine Anweisung wie xkoord=xkoord-xins
		wrde bei *jedem* repaint aufs neue ausgefhrt.
		deswegen gibt es Koordinaten & "feste" Koordinaten
		*/
		int xkoordf=xkoord+(int)xins;
		int ykoordf=ykoord+(int)yins;

		/*
		Falls ausfuehrlich ==0 ist, nur ein Kstechen mit dem
		Namen malen
		*/
		if(ausfuehrlich==0){
			g.drawRect(xkoordf,ykoordf,300,30);
			g.drawString(Name,xkoordf+3,ykoordf+19);
		}

		/*
		Ausfuehrlich ==1 bewirkt das malen von zustzlich den Merkmalen.
		*/
		if(ausfuehrlich==1){
			g.drawString("<<"+Stereotyp+">>",xkoordf+3,ykoordf+19);
			g.drawString(Paket+"::"+Name,xkoordf+3,ykoordf+39);
			int lenM = gesamteEigenschaften.length();
			lbreakM.setPosition(0);
			int zahlM=0;
			/*
			Hier kommt das tolle. Der linebreaker kann den String in
			layouts zerhacken, die man dann einzeln malen kann.
			*/
			while( lbreakM.getPosition() < lenM ) {
				layout = lbreakM.nextLayout(280);
				zahlM++;
				layout.draw(g2d,xkoordf+3,ykoordf+40+zahlM*20);
			}
			/*
			Fehlt noch das (in seiner Gre dynamische) Rechteck.
			*/
			g.drawRect(xkoordf,ykoordf,300,zahlM*20+50);
		}

		/*
		Der dritte Fall: ganz ausfhrliche Darstellung.
		Hier kommt nochmal im Prinzip das gleiche.
		Zustzlich wird die Information ber die Attribute und die
		Operationen  aus dem Klassen-Objekt geholt.
		Dann malen wir einfach ein paar Kstchen drumrum.
		*/
		if(ausfuehrlich==2){
			g.drawString("<<"+Stereotyp+">>",xkoordf+3,ykoordf+19);
			g.drawString(Paket+"::"+Name,xkoordf+3,ykoordf+39);
			int lenM = gesamteEigenschaften.length();
			lbreakM.setPosition(0);
			int zahlM=0;
			while( lbreakM.getPosition() < lenM ) {
				layout = lbreakM.nextLayout(280);
				zahlM++;
				layout.draw(g2d,xkoordf+3,ykoordf+40+zahlM*20);
			}
			g.drawRect(xkoordf,ykoordf,300,zahlM*20+50);

			int i=0;
			for(i=0; i<Attribute.size(); i++){
				Attribut att = (Attribut)Attribute.elementAt(i);
				String aName = att.getName();
				String aTyp = att.getTyp();
				String aInitialwert = att.getInitialwert();
				String aZusicherung = att.getZusicherung();
				Font normal;
				normal = new Font("SansSerif",0,12);
				g2d.setFont(normal);
				String aAus;
				if(aInitialwert==""){
					aAus = aTyp + " " +  aName;}
					else aAus = aTyp + " " +  aName + "= " +aInitialwert;
				g2d.drawString(aAus,xkoordf+3,ykoordf+zahlM*20+70+30*i);
				g2d.drawString(aZusicherung,xkoordf+3,ykoordf+zahlM*20+70+30*i+15);
			}

			g.drawRect(xkoordf,ykoordf+zahlM*20+50,300,i*30+10);

			int j=0;
			for(j=0; j<Operationen.size(); j++){
				Operation op = (Operation)Operationen.elementAt(j);
				String oName = op.getName();
				String oZusicherung = op.getZusicherung();
				String oParameter = op.getParameter();

				String oAus = oName + " (" + oParameter +")";
				g2d.drawString(oAus,xkoordf+3,ykoordf+zahlM*20+80+30*i+j*30);
				g2d.drawString("{"+ oZusicherung +"}",xkoordf+3,ykoordf+zahlM*20+80+30*i+15+j*30);
			}

			g.drawRect(xkoordf,ykoordf+zahlM*20+50+i*30+10,300,j*30+10);


		}// Ende if
	}// Ende paint


   public void actionPerformed(ActionEvent event)
   {
      String cmd = event.getActionCommand();
      if (cmd.equals("Knapp")) {
         ausfuehrlich=0;
         this.repaint();
      } else if (cmd.equals("Normal")) {
         ausfuehrlich=1;
         this.repaint();
      } else if (cmd.equals("Detailliert")) {
         ausfuehrlich=2;
         this.repaint();
      } else if (cmd.equals("Editieren")) {
      	Klasse k = new Klasse(Filename, Name, Stereotyp, Paket, PaketKlasse, Eigenschaftswerte, isStatic, Eigenschaften, Attribute, Operationen);
      	try {
      	k.editieren(k);
      	} catch(Exception e) {
      	    System.err.println();
      	    System.err.println("klassenMaler: actionPerformed ... editieren");
      	    System.err.println(e.toString());
      	}
      	this.setVisible(false);
      }
   }
  private void jbInit() throws Exception {
    jButton1.setText("jButton1");
    jButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton1_actionPerformed(e);
      }
    });
    jCheckBox1.setText("jCheckBox1");
    jCheckBox2.setText("jCheckBox2");
    jLabel1.setText("jLabel1");
    jRadioButton1.setText("jRadioButton1");
    this.add(jLabel1, BorderLayout.NORTH);
    this.add(jCheckBox1, BorderLayout.SOUTH);
    this.add(jButton1, BorderLayout.WEST);
    this.add(jCheckBox2, BorderLayout.EAST);
    this.add(jRadioButton1, BorderLayout.CENTER);
  }

  void jButton1_actionPerformed(ActionEvent e) {

  }

}// Ende der Klasse
