/*
Klasse objektMaler zum anzeigen der Informationen eines Objekts
fr ein UML-Klassendiagramm.
Autor: Karsten
Version: 02/01/01
*/

import java.awt.*;
import java.awt.font.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.text.*;
import java.util.Vector;


public class objektMaler extends Frame implements ActionListener{

/*
Zunchst einmal fhren wir die ntigen Parameter ein, die zum vollstndigen anzeigen einer Klasse ntig sind.
Alle werden gleich mit "Settern" versehen. 
*/

private String Name="";

private String Filename="";

private String OberKlasse="";

private Vector InAttribute = new Vector();


/*
Der Parameter "ausfhrlich"  steht fr den Detailliertheitsgrad der Anzeige.
0 entspricht "knapp"
1 entspricht "normal"
2 entspricht "detailliert"
*/
private int ausfuehrlich =2;

/* 
die Koordinaten der oberen linken Ecke des Kstchens.private int xkoord= 20
die sind variabel, damit man die entsprechenden Teile spter weiter verwenden kann
*/
private int ykoord = 20;
private int xkoord = 20;

/*
Hilfsobjekte, um spter den "Eigenschaften-String" umbrechen zu knnen
*/
private AttributedCharacterIterator iterM;	
private LineBreakMeasurer lbreakM;		

/*
Damit man weiss, wie gro der Rahmen ist
*/
private Insets inset;				


	/*
	Konstruktor sorgt dafr, dass ein Frame aufgemacht wird, der 
	a) wegkllckbar ist,
	b) eine noch veraenderbare Groesse hat.
	c) um seine Insets (die vom Rahmen verschluckte Flche) wei
	*/
	public objektMaler(){
		super("Objekt-Anzeige");
		addWindowListener(
   		new WindowAdapter(){
   			public void windowClosing(WindowEvent event){
   				event.getWindow().setVisible(false);
   			}
   		}
   		);
   		setBackground(Color.white);
   		setSize(400,500);
   		setVisible(true);
   		inset = getInsets();
   		setMenuBar(new menueOB(this));
   	}// Ende Konstruktor
   	
   	
   	 public static void malen(Objekt ob) {
   	 	objektMaler duerer = new objektMaler();
   	 	duerer.Name=ob.getName();
   	 	duerer.OberKlasse=ob.getOberKlasse();
   	 	duerer.InAttribute=ob.getInAttribute();
   	 	duerer.Filename=ob.getFilename();
   	 	duerer.repaint();
   	}
   	
   	
	
	public void paint(Graphics g) {
		/*
		das casten braucht man, um nachher layouts anzeigen zu knnen.
		*/
		Graphics2D g2d = (Graphics2D)g;
		/*
		das hier sind die ntigen Hilfskonstruktionen fr das umbrechen der drei
		"lngeren" Strings, Merkmale, Attribute und Operationen.
		*/
		g2d.setColor(Color.black);
		/*
		Nur fr die explizit als Strings angezeigten Elemente
		verwenden wir eine besondere Schriftart. Das geht dann
		nachher einfacher. 
		*/
		Font Font;
		Font = new Font("SansSerif",1,12);
		g2d.setFont(Font);
		/*
		Jetzt kommen ein paar Objekte, die man braucht, um Text umbrechen zu koennen.
		ein Layout, das spter angezeigt wird, einen Fontrenderkontext, der zum Beispiel
		um die Gre der Schrift wei sowie einen Iterator, der immer Teile des attributierten
		Strings ausgibt.
		Das ganze brauchen wir fr alle Elemente, die u.u. aus mehr als einem Wort bestehen.
		*/
		TextLayout layout;
		FontRenderContext fcontext = ((Graphics2D)getGraphics()).getFontRenderContext();
				
		/*
		Der "beschreibbare" Platz liegt ausschlielich im innern des 
		Frames. 
		*/
		float xins = inset.left;
		float yins = inset.top;
		
		/*
		Problem: eine Anweisung wie xkoord=xkoord-xins 
		wrde bei *jedem* repaint aufs neue ausgefhrt.
		deswegen gibt es Koordinaten & "feste" Koordinaten
		*/
		int xkoordf=xkoord+(int)xins;
		int ykoordf=ykoord+(int)yins;
		
		/*
		Falls ausfuehrlich ==0 ist, nur ein Kstechen mit dem 
		Namen malen
		*/
		
		FontMetrics fm = g.getFontMetrics();	
		
		if(ausfuehrlich==0){
			g.drawRect(xkoordf,ykoordf,300,40);
			g.drawString(Name,xkoordf+3,ykoordf+19);
			g.fillRect(xkoordf+3,ykoordf+21,fm.stringWidth(Name),2);
		}
		
		
		//Ausfuehrlich ==1 bewirkt das malen von zustzlich dem Namen der Oberklasse.
		
		
		 if(ausfuehrlich==1){
		 	g.drawRect(xkoordf,ykoordf,300,40);
		 	String zus = OberKlasse + " : " + Name;
		 	g.drawString(zus,xkoordf+3,ykoordf+19);
			g.fillRect(xkoordf+3,ykoordf+21,fm.stringWidth(zus),2);
			
		}
		
		
		
		if(ausfuehrlich==2){
			g.drawRect(xkoordf,ykoordf,300,40);
		 	String zus = OberKlasse + " : " + Name;
		 	g.drawString(zus,xkoordf+3,ykoordf+19);
			g.fillRect(xkoordf+3,ykoordf+21,fm.stringWidth(zus),2);
			
					
			int i=0;
			for(i=0; i<InAttribute.size(); i++){
				Attribut att = (Attribut)InAttribute.elementAt(i);
				String aName = att.getName();
				String aInitialwert = att.getInitialwert();
				Font normal;
				normal = new Font("SansSerif",0,12);
				g2d.setFont(normal);
				String aAus;
				if(aInitialwert==""){
					aAus = aName;}				
					else aAus = aName + " = " +aInitialwert;
				g2d.drawString(aAus,xkoordf+3,ykoordf+60+15*i);
				}
			
			g.drawRect(xkoordf,ykoordf+40,300,i*15+10);
			
			}// Ende if
	}// Ende paint
	
	
   public void actionPerformed(ActionEvent event)
   {
      String cmd = event.getActionCommand();
      if (cmd.equals("Nur Name")) {
         ausfuehrlich=0;
         this.repaint();
      } else if (cmd.equals("Normal")) {
         ausfuehrlich=1;
         this.repaint();
      } else if (cmd.equals("Mit Attributen")) {
         ausfuehrlich=2;
         this.repaint();
      } else if (cmd.equals("Editieren")) {
      	 Objekt o = new Objekt(Filename, Name, OberKlasse, InAttribute);
      	 o.editieren(o);
      	 this.setVisible(false);
      	 //Objekte.editieren(o);
      	 
      	
      }
   }
	
}// Ende der Klasse
