/*
Klasse usecaseMaler zum anzeigen der Informationen einer Klasse 
fr ein UML-Use-Case-Diagramm
Autor: Karsten
Version: 02/01/01
*/

import java.awt.*;
import java.awt.font.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.text.*;
import java.util.Vector;


public class usecaseMaler extends Frame implements ActionListener{

/*
Zunchst einmal fhren wir die ntigen Parameter ein, die zum vollstndigen anzeigen einer Klasse ntig sind.
Auf Setter verzichten wir einfach mal.
*/
private String Filename="Filename";
private String Name="Name";
private String Nummer="Nummer";
private String Akteur="default";
private String Vorbedingungen="default";
private String Nachbedingungen="default";
private String Invarianten="default";
private String Ablaufbeschreibung="default";
private String Variationen="default";
private String Dialog="default";

private String Anforderungen="default";//E fr erweitert(nur erweiterter Fall)
private String Ausnahmen="default";
private String Regeln="default";
private String Services="Da fllt mir nichts ein";
private String Ansprechpartner="default";
private String Anmerkungen="default";
private String Dialogbeispiel="default";



/*
Der Parameter "ausfhrlich"  steht fr den Detailliertheitsgrad der Anzeige.
0 entspricht "Nur die Ellipse"
1 entspricht "normale Eigenschaften"
2 entspricht "Nur Details"
*/
private int ausfuehrlich =0;

/* 
die Koordinaten der oberen linken Ecke des Kstchens.private int xkoord= 20
die sind variabel, damit man die entsprechenden Teile spter weiter verwenden kann
*/
private int ykoord = 20;
private int xkoord = 20;

/*
Hilfsobjekte, um spter den "Eigenschaften-String" umbrechen zu knnen
Davon brauchen wir jetzt eine ganze Menge (13!), einen fr jeden
"langen" String
*/

// vorbedingungen
private AttributedCharacterIterator iterVO;	
private LineBreakMeasurer lbreakVO;		

// nachbedingungen
private AttributedCharacterIterator iterNA;	
private LineBreakMeasurer lbreakNA;		

// Invarianten
private AttributedCharacterIterator iterIN;	
private LineBreakMeasurer lbreakIN;		

// Ablaufbeschreibung
private AttributedCharacterIterator iterAB;	
private LineBreakMeasurer lbreakAB;		

// Vartiationen 
private AttributedCharacterIterator iterVA;	
private LineBreakMeasurer lbreakVA;		

// Dialog
private AttributedCharacterIterator iterDI;	
private LineBreakMeasurer lbreakDI;		

// Anforderungen
private AttributedCharacterIterator iterAN;	
private LineBreakMeasurer lbreakAN;		

// Ausnahmen
private AttributedCharacterIterator iterAU;	
private LineBreakMeasurer lbreakAU;		

// Regeln
private AttributedCharacterIterator iterRE;	
private LineBreakMeasurer lbreakRE;		

// Services
private AttributedCharacterIterator iterSE;	
private LineBreakMeasurer lbreakSE;		

// Ansprechpartner
private AttributedCharacterIterator iterAP;	
private LineBreakMeasurer lbreakAP;		

// Anmerkungen
private AttributedCharacterIterator iterAM;	
private LineBreakMeasurer lbreakAM;		

// Dialogbeispiel
private AttributedCharacterIterator iterDB;	
private LineBreakMeasurer lbreakDB;		


/*
Damit man weiss, wie gro der Rahmen ist
*/
private Insets inset;				


	/*
	Konstruktor sorgt dafr, dass ein Frame aufgemacht wird, der 
	a) wegkllckbar ist,
	b) eine noch veraenderbare Groesse hat.
	c) um seine Insets (die vom Rahmen verschluckte Flche) wei
	*/
	public usecaseMaler(){
		super("Use-Case-Anzeige");
		addWindowListener(
   		new WindowAdapter(){
   			public void windowClosing(WindowEvent event){
   				event.getWindow().setVisible(false);
   			}
   		}
   		);
   		setBackground(Color.white);
   		setSize(1000,600);
   		setVisible(true);
   		inset = getInsets();
   		setMenuBar(new menueUC(this));
   	}// Ende Konstruktor
   	
   	   	
   	
   	 public static void malen(UseCase use) {
   	 	usecaseMaler klein = new usecaseMaler();
   	 	
   	 	klein.Name = use.getName();
   	 	klein.Akteur = use.getAkteur();
   	 	klein.Nummer = use.getNummer();
   	 	klein.Nachbedingungen = use.getNachbedingungen();
   	 	klein.Vorbedingungen = use.getVorbedingungen();
   	 	klein.Invarianten = use.getInvarianten();
   	 	klein.Ablaufbeschreibung = use.getAblaufbeschreibung();
   	 	klein.Variationen = use.getVariationen();
   	 	klein.Dialog = use.getDialog();
   	 	klein.Anforderungen = use.getAnforderungen();
   	 	klein.Ausnahmen = use.getAusnahmen();
   	 	klein.Regeln = use.getRegeln();
   	 	klein.Services = use.getServices();
   	 	klein.Ansprechpartner = use.getAnsprechpartner();
   	 	klein.Anmerkungen = use.getAnmerkungen();
   	 	klein.Variationen = use.getVariationen();
   	 	klein.Dialogbeispiel = use.getDialogbeispiel();
   	}
   	
   	
   	
   	public void paint(Graphics g) {
		/*
		das casten braucht man, um nachher layouts anzeigen zu knnen.
		*/
		Graphics2D g2d = (Graphics2D)g;
		/*
		das hier sind die ntigen Hilfskonstruktionen fr das umbrechen der drei
		"lngeren" Strings, Merkmale, Attribute und Operationen.
		*/
		g2d.setColor(Color.black);
		/*
		Nur fr die explizit als Strings angezeigten Elemente
		verwenden wir eine besondere Schriftart. Das geht dann
		nachher einfacher. 
		*/
		Font Font;
		Font = new Font("SansSerif",1,12);
		g2d.setFont(Font);
		/*
		Jetzt kommen ein paar Objekte, die man braucht, um Text umbrechen zu koennen.
		ein Layout, das spter angezeigt wird, einen Fontrenderkontext, der zum Beispiel
		um die Gre der Schrift wei sowie einen Iterator, der immer Teile des attributierten
		Strings ausgibt.
		Das ganze brauchen wir fr alle Elemente, die u.u. aus mehr als einem Wort bestehen.
		*/
		TextLayout layout;
		FontRenderContext fcontext = ((Graphics2D)getGraphics()).getFontRenderContext();
		
		
		/*
		Fr jeden "langen" Text ein LineBreakMeasurer
		*/
		if(Vorbedingungen!=""){	
		iterVO = (new AttributedString(Vorbedingungen)).getIterator();
		lbreakVO = new LineBreakMeasurer(iterVO,fcontext);
		lbreakVO.setPosition(0);
		}
		
		if(Nachbedingungen!=""){
		iterNA = (new AttributedString(Nachbedingungen)).getIterator();
		lbreakNA = new LineBreakMeasurer(iterNA,fcontext);
		lbreakNA.setPosition(0);
		}
		
		if(Invarianten!=""){
		iterIN = (new AttributedString(Invarianten)).getIterator();
		lbreakIN = new LineBreakMeasurer(iterIN,fcontext);
		lbreakIN.setPosition(0);
		}
	
		if(Ablaufbeschreibung!=""){
		iterAB = (new AttributedString(Ablaufbeschreibung)).getIterator();
		lbreakAB = new LineBreakMeasurer(iterAB,fcontext);
		lbreakAB.setPosition(0);
		}
		
		if(Variationen!=""){
		iterVA = (new AttributedString(Variationen)).getIterator();
		lbreakVA = new LineBreakMeasurer(iterVA,fcontext);
		lbreakVA.setPosition(0);
		}
		
		if(Dialog!=""){
		iterDI = (new AttributedString(Dialog)).getIterator();
		lbreakDI = new LineBreakMeasurer(iterDI,fcontext);
		lbreakDI.setPosition(0);
		}
		
		if(Anforderungen!=""){
		iterAN = (new AttributedString(Anforderungen)).getIterator();
		lbreakAN = new LineBreakMeasurer(iterAN,fcontext);
		lbreakAN.setPosition(0);
		}
		
		if(Ausnahmen!=""){
		iterAU = (new AttributedString(Ausnahmen)).getIterator();
		lbreakAU = new LineBreakMeasurer(iterAU,fcontext);
		lbreakAU.setPosition(0);
		}
		
		if(Regeln!=""){
		iterRE = (new AttributedString(Regeln)).getIterator();
		lbreakRE = new LineBreakMeasurer(iterRE,fcontext);
		lbreakRE.setPosition(0);
		}
		
		if(Services!=""){
		iterSE = (new AttributedString(Services)).getIterator();
		lbreakSE = new LineBreakMeasurer(iterSE,fcontext);
		lbreakSE.setPosition(0);
		}
		
		if(Ansprechpartner!=""){
		iterAP = (new AttributedString(Ansprechpartner)).getIterator();
		lbreakAP = new LineBreakMeasurer(iterAP,fcontext);
		lbreakAP.setPosition(0);
		}
		
		if(Anmerkungen!=""){
		iterAM = (new AttributedString(Anmerkungen)).getIterator();
		lbreakAM = new LineBreakMeasurer(iterAM,fcontext);
		lbreakAM.setPosition(0);
		}
		
		if(Dialogbeispiel!=""){
		iterDB = (new AttributedString(Dialogbeispiel)).getIterator();
		lbreakDB = new LineBreakMeasurer(iterDB,fcontext);
		lbreakDB.setPosition(0);
		}
		
		
				
		/*
		Der "beschreibbare" Platz liegt ausschlielich im innern des 
		Frames. 
		*/
		float xins = inset.left;
		float yins = inset.top;
		
		/*
		Problem: eine Anweisung wie xkoord=xkoord-xins 
		wrde bei *jedem* repaint aufs neue ausgefhrt.
		deswegen gibt es Koordinaten & "feste" Koordinaten
		*/
		int xkoordf=xkoord+(int)xins;
		int ykoordf=ykoord+(int)yins;
		
		g.drawString("Use-Case No."+Nummer,xkoordf+15,ykoordf+15);
		
		if(ausfuehrlich==0){
			FontMetrics fm = g.getFontMetrics();
			int sLaenge = fm.stringWidth(Name);
			g.drawOval(xkoordf+15,ykoord+75,sLaenge+50,80);
			g.drawString(Name,xkoordf+40,ykoordf+70);
		}
		/*
		Um das errechnen der y-Koordinaten zu vereinfachen, zhlen wir
		einfach immer alle Zeilen mit groer Schrift (gz) und die mit
		normaler Scchrift (nz) mit. 
		*/
		if(ausfuehrlich==1){
			
			int gz=0;
			g.drawString("Name: " +Name, xkoordf+15,ykoordf+35);			
			gz++;
			g.drawString("Akteur: " +Akteur, xkoordf+15,ykoordf+35+17*gz);
			gz++;
			
			int nz=0;	
			if(Vorbedingungen!=""){
			g.drawString("Vorbedingungen:", xkoordf+15,ykoordf+35+17*gz);
			gz++;
			while( lbreakVO.getPosition() < Vorbedingungen.length() ) {	
				layout = lbreakVO.nextLayout(900);	
				layout.draw(g2d,xkoordf+15,ykoordf+35+17*gz+nz*14);
				nz++;
			}
			}// if
			
			if(Nachbedingungen!=""){
			g.drawString("Nachbedingungen:", xkoordf+15,ykoordf+35+14*nz+17*gz);
			gz++;
			while( lbreakNA.getPosition() < Nachbedingungen.length() ) {	
				layout = lbreakNA.nextLayout(900);	
				layout.draw(g2d,xkoordf+15,ykoordf+35+17*gz+nz*14);
				nz++;
			}
			}// if
			
			if(Invarianten!=""){
			g.drawString("Invarianten:", xkoordf+15,ykoordf+35+14*nz+17*gz);
			gz++;
			while( lbreakIN.getPosition() < Invarianten.length() ) {	
				layout = lbreakIN.nextLayout(900);	
				layout.draw(g2d,xkoordf+15,ykoordf+35+17*gz+nz*14);
				nz++;
			}
			}//if
			
			if(Ablaufbeschreibung!=""){
			g.drawString("Ablaufbeschreibung:", xkoordf+15,ykoordf+35+17*gz+14*nz);
			gz++;
			while( lbreakAB.getPosition() < Ablaufbeschreibung.length() ) {	
				layout = lbreakAB.nextLayout(900);	
				layout.draw(g2d,xkoordf+15,ykoordf+35+17*gz+nz*14);
				nz++;
			}
			}//if
			
			if(Variationen!=""){
			g.drawString("Variationen:", xkoordf+15,ykoordf+35+14*nz+17*gz);
			gz++;
			while( lbreakVA.getPosition() < Variationen.length() ) {	
				layout = lbreakVA.nextLayout(900);	
				layout.draw(g2d,xkoordf+15,ykoordf+35+17*gz+nz*14);
				nz++;
			}// if
			}
			
			if(Dialog!=""){
			g.drawString("Dialog:", xkoordf+15,ykoordf+35+14*nz+17*gz);
			gz++;
			while( lbreakDI.getPosition() < Dialog.length() ) {	
				layout = lbreakDI.nextLayout(900);	
				layout.draw(g2d,xkoordf+15,ykoordf+35+17*gz+nz*14);
				nz++;
			}
			}//if
			
			
			
			
		}// ende ausfuehrlich == 1
		
		if(ausfuehrlich==2){
			int gz=0;
			int nz=0;		
			g.drawString("Name: " +Name, xkoordf+15,ykoordf+35);			
			gz++;
			
			if(Anforderungen!=""){
			g.drawString("Anforderungen:", xkoordf+15,ykoordf+35+17*gz);
			gz++;
			while( lbreakAN.getPosition() < Anforderungen.length() ) {	
				layout = lbreakAN.nextLayout(900);	
				layout.draw(g2d,xkoordf+15,ykoordf+35+17*gz+nz*14);
				nz++;
			}
			}//if
			
			if(Ausnahmen!=""){
			g.drawString("Ausnahmen:", xkoordf+15,ykoordf+35+14*nz+17*gz);
			gz++;
			while( lbreakAU.getPosition() < Ausnahmen.length() ) {	
				layout = lbreakAU.nextLayout(900);	
				layout.draw(g2d,xkoordf+15,ykoordf+35+17*gz+nz*14);
				nz++;
			}
			}// if 
			
			if(Regeln!=""){
			g.drawString("Regeln:", xkoordf+15,ykoordf+35+14*nz+17*gz);
			gz++;
			while( lbreakRE.getPosition() < Regeln.length() ) {	
				layout = lbreakRE.nextLayout(900);	
				layout.draw(g2d,xkoordf+15,ykoordf+35+17*gz+nz*14);
				nz++;
			}
			}// if 
			
			if(Services!=""){
			g.drawString("Services:", xkoordf+15,ykoordf+35+17*gz+14*nz);
			gz++;
			while( lbreakSE.getPosition() < Services.length() ) {	
				layout = lbreakSE.nextLayout(900);	
				layout.draw(g2d,xkoordf+15,ykoordf+35+17*gz+nz*14);
				nz++;
			}
			}//If
			
			if(Ansprechpartner!=""){
			g.drawString("Ansprechpartner:", xkoordf+15,ykoordf+35+14*nz+17*gz);
			gz++;
			while( lbreakAP.getPosition() < Ansprechpartner.length() ) {	
				layout = lbreakAP.nextLayout(900);	
				layout.draw(g2d,xkoordf+15,ykoordf+35+17*gz+nz*14);
				nz++;
			}
			}
			
			if(Anmerkungen!=""){
			g.drawString("Anmerkungen:", xkoordf+15,ykoordf+35+14*nz+17*gz);
			gz++;
			while( lbreakAM.getPosition() < Anmerkungen.length() ) {	
				layout = lbreakAM.nextLayout(900);	
				layout.draw(g2d,xkoordf+15,ykoordf+35+17*gz+nz*14);
				nz++;
			}
			}//if
			
			if(Dialogbeispiel!=""){
			g.drawString("Dialogbeispiele:", xkoordf+15,ykoordf+35+14*nz+17*gz);
			gz++;
			while( lbreakDB.getPosition() < Dialogbeispiel.length() ) {	
				layout = lbreakDB.nextLayout(900);	
				layout.draw(g2d,xkoordf+15,ykoordf+35+17*gz+nz*14);
				nz++;
			}
			}//if
		}// Ende ausfuehrlich==2
		
			
		
			
		
		
	}// Ende paint
	
	
   public void actionPerformed(ActionEvent event)
   {
      String cmd = event.getActionCommand();
      if (cmd.equals("Elliptisch")) {
         ausfuehrlich=0;
         this.repaint();
      } else if (cmd.equals("Normal")) {
         ausfuehrlich=1;
         this.repaint();
      } else if (cmd.equals("Nur Details")) {
         ausfuehrlich=2;
         this.repaint();
      } else if (cmd.equals("Editieren")) {
      	UseCase u = new UseCase(Filename, Name, Nummer, Akteur, Vorbedingungen, Nachbedingungen, Invarianten, Ablaufbeschreibung, Variationen, Dialog, Anforderungen, Ausnahmen, Regeln, Services, Ansprechpartner, Anmerkungen, Dialogbeispiel);
      	u.editieren(u);
      	this.setVisible(false);
      }
   }
	
}// Ende der Klasse
