/*
Klasse verbindungsMaler zum anzeigen der Informationen einer Verbindung
fr ein UML-Klassendiagramm.
Autor: Karsten
Version: 03/00/01
*/

import java.awt.*;
import java.awt.font.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.text.*;
import java.util.Vector;

public class verbindungsMaler extends Frame implements ActionListener{

/*
Die folgenden Werte werden in einer endgltigen Version
dynamisch vom Programm aus gesetzt (oder aus einer Datei geholt).
Wer hat sich eigentlich die komischen Namen ausgedacht?
*/

private String Name="";
private String Stereotyp="";
private String Beziehungsname="";
private String Zusicherung="";
private String Eigenschaftswerte="";
private String Mlinks="";//Multiplizitt links
private String Mrechts="";//M rechts
private String Filename="";
private int Leserichtung;//0 fr <, 1 fr >
private boolean isGestrichelt;
private int Spitze=1;       //0=links 1=rechts 2=keine Spitze
private int SpitzenForm=4;  //0= offen 1= dreieckigunausgefllt 2= dreieckig ausgefllt 3=Raute unausgefllt 
		            //4=Raute ausgefllt
private int ausfuehrlich=1; //0=einfach 1=standard 2=komplett
    
private int xkoord= 100;
private int ykoord = 100;

private Insets inset;				



	/*
	Konstruktor sorgt dafr, dass ein Frame aufgemacht wird, der 
	a) wegkllckbar ist,
	b) eine noch veraenderbare Groesse hat.
	c) um seine Insets (die vom Rahmen verschluckte Flche) wei
	*/
	public verbindungsMaler(){
		super("Verbindungs-Anzeige");
		addWindowListener(
   		new WindowAdapter(){
   			public void windowClosing(WindowEvent event){
   				event.getWindow().setVisible(false);
   			}
   		}
   		);
   		setBackground(Color.white);
   		setSize(800,400);
   		setVisible(true);
   		inset = getInsets();
   		setMenuBar(new menueVE(this));
   		setVisible(true);
   	}// Ende Konstruktor
   	
   	public static void malen(Verbindung ver){
   		verbindungsMaler grunewald = new verbindungsMaler();
   		grunewald.Name = ver.getName();
   		grunewald.Stereotyp=ver.getStereotyp();
   		grunewald.Zusicherung = ver.getZusicherung();
   		grunewald.Beziehungsname=ver.getBeziehungsname();
   		grunewald.Eigenschaftswerte=ver.getEigenschaftswerte();
   		grunewald.Mlinks=ver.getMlinks();
   		grunewald.Mrechts=ver.getMrechts();
   		grunewald.Leserichtung=ver.getLeserichtung();
   		grunewald.isGestrichelt=ver.getisGestrichelt();
   		grunewald.Spitze=ver.getSpitze();
   		grunewald.SpitzenForm=ver.getSpitzenForm();
   		grunewald.Filename=ver.getFilename();
   		grunewald.repaint();
   	}
   	
   	
   	
   	/*
   	Hilfsmethode. Hier lt sich eine paint Methode mit mehr als einem Argument aufrufen.
   	Es wird "gesettet" und dann die eigentliche Methode, paint(g), aufgerufen.
   	Im Moment noch nutzlos, braucht man vielleicht spter.
   	*/
	
	public void paint(Graphics g) {
		
		float xins = inset.left;
		float yins = inset.top;
		
		
		g.setColor(Color.black);
		/*
		Fr das Platzieren der Strings brauchen wir deren Lnge
		in der entsprechenden Schriftart, dazu die Fontmetriken.
		*/
		Font Font;
		Font = new Font("SansSerif",1,12);
		g.setFont(Font);
				
		
		int xkoordf=xkoord+(int)xins;
		int ykoordf=ykoord+(int)yins;
		
		
		
		/*
		Zuerst: die Linie malen
		*/
		if(isGestrichelt){
			for(int x=0; x < 500; x=x+5){
				g.drawLine(xkoordf+50+x,ykoordf+50,xkoordf+50+x+5,ykoordf+50);
				x=x+10;
			}// for-ende
		}// if-ende
		
		if(!isGestrichelt){
			g.drawLine(xkoordf+50,ykoordf+50,xkoordf+550,ykoordf+50);
		}
		
					
		/*
		Dann: die Spitze malen.
		*/
		
		if(Spitze==0)// Spitze links
		{
			if(SpitzenForm==0){
				g.drawLine(xkoordf+535,ykoordf+35,xkoordf+550,ykoordf+50);
				g.drawLine(xkoordf+535,ykoordf+65,xkoordf+550,ykoordf+50);
			}// Normnale Spitze rechts
			
			if(SpitzenForm==1){
				g.drawLine(xkoordf+550,ykoordf+35,xkoordf+550,ykoordf+65);
				g.drawLine(xkoordf+550,ykoordf+35,xkoordf+565,ykoordf+50);
				g.drawLine(xkoordf+550,ykoordf+65,xkoordf+565,ykoordf+50);
			}// dreieck rechts
			
			if(SpitzenForm==2){
				int arx[] = {xkoordf+550,xkoordf+550,xkoordf+565};
				int ary[] = {ykoordf+35,ykoordf+65,ykoordf+50};
				g.fillPolygon(arx,ary,arx.length);
			}// Ausgeflltes dreieck rechts
			
			if(SpitzenForm==3){
				int arx[] = {xkoordf+550,xkoordf+560,xkoordf+570,xkoordf+560};
				int ary[] = {ykoordf+50,ykoordf+60,ykoordf+50,ykoordf+40};
				g.drawPolygon(arx,ary,arx.length);
			} // Raute rechts
			
			if(SpitzenForm==4){
				int arx[] = {xkoordf+550,xkoordf+560,xkoordf+570,xkoordf+560};
				int ary[] = {ykoordf+50,ykoordf+60,ykoordf+50,ykoordf+40};
				g.fillPolygon(arx,ary,arx.length);
			} // ausgefllte  Raute rechts
		}// ende Spitze==0
		
		if(Spitze==1){
			
			if(SpitzenForm==0){
				g.drawLine(xkoordf+65,ykoordf+35,xkoordf+50,ykoordf+50);
				g.drawLine(xkoordf+65,ykoordf+65,xkoordf+50,ykoordf+50);
			}// Normnale Spitze links
			
			if(SpitzenForm==1){
				int arx[] = {xkoordf+35,xkoordf+50,xkoordf+50};
				int ary[] = {ykoordf+50,ykoordf+65,ykoordf+35};
				g.drawPolygon(arx,ary,arx.length);
			}// dreieck links
			
			if(SpitzenForm==2){
				int arx[] = {xkoordf+35,xkoordf+50,xkoordf+50};
				int ary[] = {ykoordf+50,ykoordf+65,ykoordf+35};
				g.fillPolygon(arx,ary,arx.length);
			}// Ausgeflltes dreieck rechts
			
			if(SpitzenForm==3){
				int arx[] = {xkoordf+50,xkoordf+40,xkoordf+30,xkoordf+40};
				int ary[] = {ykoordf+50,ykoordf+40,ykoordf+50,ykoordf+60};
				g.drawPolygon(arx,ary,arx.length);
			} // Raute links
			
			if(SpitzenForm==4){
				int arx[] = {xkoordf+50,xkoordf+40,xkoordf+30,xkoordf+40};
				int ary[] = {ykoordf+50,ykoordf+40,ykoordf+50,ykoordf+60};
				g.fillPolygon(arx,ary,arx.length);
			} // ausgefllte  Raute links
			
			
		}// Ende Spitze==1 (links)
		
		
		
		
		//Jetzt: Den Namen malen:
		g.drawString(Name,xkoordf,ykoordf);
		
		/*
		Jetzt kommen die Beschriftungen
		*/
	FontMetrics fm = g.getFontMetrics();	
		
	if(ausfuehrlich > 0){
		
			
		int BeziehungsnameLaenge =0;
		String Beziehungsnamef="";		
		// Verbindungsname & Richtung
		if (Leserichtung==0){
			Beziehungsnamef = "<" + Beziehungsname;
			BeziehungsnameLaenge = fm.stringWidth(Beziehungsname);
		}// Leserichtung links
		
		if (Leserichtung==1){
			Beziehungsnamef = Beziehungsname + ">";
			BeziehungsnameLaenge = fm.stringWidth(Beziehungsname);
		}// Leserichtung rechts
		
		g.drawString(Beziehungsnamef,xkoordf+250-BeziehungsnameLaenge/2,ykoordf+35);
		
	}// Ausfuehrlich > 0
	
	if(ausfuehrlich>1){
		
		int MlinksLaenge = fm.stringWidth(Mlinks);
		int MrechtsLaenge = fm.stringWidth(Mrechts);
						
		// Multiplikativitt links & rechts
		g.drawString(Mlinks,xkoordf+50,ykoordf+47);
		g.drawString(Mrechts,xkoordf+550-MrechtsLaenge,ykoordf+47);
		
		
		String Stereotypf = "{"+Stereotyp+"}";
		int StereotypLaenge = fm.stringWidth(Stereotypf);
		g.drawString(Stereotypf,xkoordf+250-StereotypLaenge/2,ykoordf+20);
		
		String Zusicherungf = "{"+Zusicherung+"}";
		int ZusicherungLaenge = fm.stringWidth(Zusicherungf);
		
		g.drawString(Zusicherungf,xkoordf+250-ZusicherungLaenge/2,ykoordf+70);
		
	}// Ausfuehrlich =2
		
	}// Ende paint
	
	

	
	
	
	public void actionPerformed(ActionEvent event)
   {
      String cmd = event.getActionCommand();
      if (cmd.equals("Nur Pfeil")) {
         ausfuehrlich=0;
         this.repaint();
      } else if (cmd.equals("Normal")) {
         ausfuehrlich=1;
         this.repaint();
      } else if (cmd.equals("Detailliert")) {
         ausfuehrlich=2;
         this.repaint();
      } else if (cmd.equals("Editieren")) {
      	Verbindung v = new Verbindung(Filename, Name, Stereotyp, Beziehungsname, Zusicherung, Eigenschaftswerte, Mlinks, Mrechts, Leserichtung, isGestrichelt, Spitze, SpitzenForm);
     	v.editieren(v);
      	this.setVisible(false);
      	
}

   }
   
   
}// Ende der Klasse
